/*
 * *************************************************
 * Copyright (c) 2018 QMTH. All Rights Reserved.
 * Created by Deason on 2018-10-30 11:39:43.
 * *************************************************
 */

package cn.com.qmth.examcloud.core.print.enums;

public enum QuesStructType {
    SINGLE_ANSWER_QUESTION(1, "单选", true, false),
    MULTIPLE_ANSWER_QUESTION(2, "多选", true, false),
    BOOL_ANSWER_QUESTION(3, "判断", true, false),
    FILL_BLANK_QUESTION(4, "填空", false, false),
    TEXT_ANSWER_QUESTION(5, "问答", false, false),
    NESTED_ANSWER_QUESTION(6, "套题", false, true);

    private Integer id;
    private String title;
    private boolean objective;//是否是客观题
    private boolean combine;//是否是组合题

    public static QuesStructType getByName(String name) {
        if (name == null) {
            return null;
        }
        for (QuesStructType type : QuesStructType.values()) {
            if (type.name().equals(name)) {
                return type;
            }
        }
        return null;
    }

    QuesStructType(Integer id, String title, boolean objective, boolean combine) {
        this.id = id;
        this.title = title;
        this.objective = objective;
        this.combine = combine;
    }

    public Integer getId() {
        return id;
    }

    public String getTitle() {
        return title;
    }

    public boolean isObjective() {
        return objective;
    }

    public boolean isCombine() {
        return combine;
    }

}