/*
 * *************************************************
 * Copyright (c) 2018 QMTH. All Rights Reserved.
 * Created by Deason on 2018-10-22 15:24:57.
 * *************************************************
 */

package cn.com.qmth.examcloud.core.print.service;

import cn.com.qmth.examcloud.core.print.entity.CoursePaper;
import cn.com.qmth.examcloud.core.print.service.bean.coursepaper.*;

import java.io.File;
import java.util.List;

/**
 * @author: fengdesheng
 * @since: 2018/10/22
 */
public interface CoursePaperService {

    /**
     * 获取课程试卷(简要)信息列表
     */
    List<CoursePaperLessInfo> getCoursePaperList(CoursePaperQuery query);

    /**
     * 同步更新课程名称信息
     */
    void syncCourseNameByCourseId(Long courseId, String courseName);

    /**
     * 同步考试课程的试卷
     */
    void syncCoursePaper(CoursePaper coursePaper);

    /**
     * (单个)分配待指定试卷
     *
     * @param courseStatisticId 课程统计ID
     * @param coursePaperId     课程试卷ID
     */
    void allotCoursePaper(Long courseStatisticId, Long coursePaperId);

    /**
     * (整体)分配待指定试卷
     */
    void allotAllCoursePaper(Long orgId, Long examId);

    /**
     * 获取某学校考试的试卷数量情况
     */
    CoursePaperTotalInfo getPaperTotalByOrgIdAndExamId(Long orgId, Long examId);

    /**
     * 批量导出(导出试卷、答案、试卷结构等文件)
     */
    File exportBatchCoursePaper(ExportBatchReq req);

    /**
     * 整体导出(导出试卷、答案、试卷结构等文件)
     */
    File exportAllCoursePaper(ExportAllReq req);

}